#line 1 "F:/MikroC/KnigntRider/anim.c"
#line 1 "f:/mikroc/knigntrider/anim.h"
#line 1 "f:/mikroc/knigntrider/fader.h"
#line 17 "f:/mikroc/knigntrider/fader.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;





 typedef struct {

 uint aryuintStates[2];
 uint uintRepeat;
 } scheduleDef;

 typedef struct faderNode {
 unsigned uBounce : 1;
 unsigned uDirection : 1;
 unsigned uLoop : 1;
 unsigned uPin : 3;
 unsigned uState : 1;
 unsigned uStop : 1;
 volatile ushort* pPort;
 uint uintSteps;
 int intStep;
 int intLastStep;
 uint uintCtr;
 uint uintRepeat;

 void (*pCB)();

 scheduleDef* pSchItem;

 struct faderNode* pNext;
 } faderDef;


 boolean createFader(faderDef* pFader, byte* pPort, byte uPin,
 uint uintSteps, boolean blnDir, boolean blnBounce,
 boolean blnLoop, boolean blnState, boolean blnStopped,
 void (*pCB)());
 int createSchedule(uint uintInc, uint uintRepeat);
 void serviceFaders();
#line 18 "f:/mikroc/knigntrider/anim.h"
 typedef struct {
 byte bPin;
 uint uintPreDelay;
 uint uintPostDelay;
 faderDef fader;
 } outputScheduleDef;

 typedef struct _animDef {
 volatile ushort* pPort;
 byte bTotalSteps;
 union {
 char bits;
 struct {
 unsigned uLoop : 1;
 unsigned uBounce : 1;
 unsigned uDir : 1;
 unsigned uStop : 1;
 };
 } flags;
 outputScheduleDef* parySeq;
 int intIndex;
 byte bStage;
 uint uintCtr;
 struct _animDef* pCurrent;
 struct _animDef* pHead;
 struct _animDef* pTail;
 struct _animDef* pPrev;
 struct _animDef* pNext;
 } animDef;


 void initAnim(animDef* pAnim, int intSteps);
 void joinAnims(animDef* pDst, animDef* pSrc);
 void playAnimation(animDef* pAnim);
#line 52 "F:/MikroC/KnigntRider/anim.c"
void initAnim(animDef* pAnim, int intSteps) {
 outputScheduleDef* pStep;
 int i;
 for( i=0; i<pAnim->bTotalSteps; i++ ) {
 pStep = &pAnim->parySeq[i];
 createFader(&pStep->fader, pAnim->pPort, pStep->bPin,
 (uint)intSteps, TRUE, FALSE, FALSE, FALSE, TRUE,  ((void*)0) );
 }
}
#line 72 "F:/MikroC/KnigntRider/anim.c"
void joinAnims(animDef* pDst, animDef* pSrc) {
 if ( pDst ==  ((void*)0)  || pSrc ==  ((void*)0)  ) {

 return;
 }
 if ( pDst->pNext ==  ((void*)0)  ) {

 pSrc->pPrev = pDst;
 pDst->pNext = pSrc;
 } else {

 animDef* pNext;
 for( pNext=pDst; pNext->pNext!= ((void*)0) ; pNext=pNext->pNext ) {
 pNext->pTail = pSrc;
 }
 pSrc->pPrev = pNext;
 pNext->pNext = pNext->pTail = pSrc;
 }
 pDst->pHead = pSrc->pHead = pDst;
 pDst->pTail = pSrc->pTail = pSrc;

 pSrc->intIndex = (pSrc->flags.uDir == 0) ? 0 : pSrc->bTotalSteps - 1;
 pDst->intIndex = (pDst->flags.uDir == 0) ? 0 : pDst->bTotalSteps - 1;

 if ( pDst->pHead->flags.uDir == 0 ) {

 pDst->pHead->pCurrent = pDst->pHead;
 } else {

 pDst->pHead->pCurrent = pDst->pTail;
 }
}
#line 114 "F:/MikroC/KnigntRider/anim.c"
void playAnimation(animDef* pAnim) {
 outputScheduleDef* pCurSeq;
 animDef* pCurAnim;

 if ( pAnim->flags.uStop ) {

 return;
 }
 if ( pAnim->pCurrent ==  ((void*)0)  ) {

 pAnim->pCurrent = pAnim;
 }
 pCurAnim = pAnim->pCurrent;

 if ( pCurAnim->flags.uDir == 0 ) {

 if ( pCurAnim->intIndex >= (int)pCurAnim->bTotalSteps ) {
 if ( pCurAnim->flags.uBounce == 1 ) {
 pCurAnim->flags.uDir = ~pCurAnim->flags.uDir;
 pCurAnim->intIndex = (int)(pCurAnim->bTotalSteps - 1);
 } else {
 if ( !pCurAnim->flags.uLoop ) {

 pCurAnim->flags.uStop = 1;
 return;
 }

 pCurAnim->intIndex = 0;
 }

 if ( pCurAnim->pNext ) {

 pCurAnim = pCurAnim->pNext;
 } else if ( !pCurAnim->flags.uBounce && pCurAnim->pHead ) {
 pCurAnim = pCurAnim->pHead;
 }
 if ( pCurAnim->pHead ) {
 pCurAnim->pHead->pCurrent = pCurAnim;
 }
 }
 } else {

 if ( pCurAnim->intIndex < 0 ) {
 if ( pCurAnim->flags.uBounce == 1 ) {
 pCurAnim->flags.uDir = ~pCurAnim->flags.uDir;
 pCurAnim->intIndex = 0;
 } else {
 if ( !pCurAnim->flags.uLoop ) {

 pCurAnim->flags.uStop = 1;
 return;
 }

 pCurAnim->intIndex = (int)(pCurAnim->bTotalSteps - 1);
 }

 if ( pCurAnim->pPrev ) {

 pCurAnim = pCurAnim->pPrev;
 } else if ( !pCurAnim->flags.uBounce && pCurAnim->pTail ) {
 pCurAnim = pCurAnim->pTail;
 }
 if ( pCurAnim->pHead ) {
 pCurAnim->pHead->pCurrent = pCurAnim;
 }
 }
 }
 pCurSeq = pCurAnim->parySeq;
 pCurSeq = &pCurSeq[pCurAnim->intIndex];

 switch((int)pCurAnim->bStage) {
 case 0:

 if ( pCurSeq->uintPreDelay == 0 ) {

 pCurAnim->bStage = 2;
 break;
 }
 pCurAnim->uintCtr = pCurSeq->uintPreDelay;
 pCurAnim->bStage = 1;
 break;
 case 1:

 if ( --pCurAnim->uintCtr == 0 ) {
 pCurAnim->bStage = 2;
 } else {
 break;
 }
 case 2:

 *pCurAnim->pPort = (1 << pCurSeq->bPin);

 pCurSeq->fader->intStep = pCurSeq->fader->uintSteps - 1;
 pCurSeq->fader->uStop = 0;

 if ( pCurSeq->uintPostDelay > 0 ) {
 pCurAnim->uintCtr = pCurSeq->uintPostDelay;
 pCurAnim->bStage = 3;
 } else {
 pCurAnim->bStage = 4;
 break;
 }
 case 3:

 if ( --pCurAnim->uintCtr == 0 ) {
 pCurAnim->bStage = 4;
 }
 break;
 case 4:

 if ( pCurAnim->flags.uDir == 0 ) {
 pCurAnim->intIndex++;
 } else {
 pCurAnim->intIndex--;
 }
 pCurAnim->bStage = 0;
 break;
 }
 serviceFaders();
}
