#line 1 "F:/MikroC/KnigntRider/fader.c"
#line 1 "f:/mikroc/knigntrider/fader.h"
#line 17 "f:/mikroc/knigntrider/fader.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;





 typedef struct {

 uint aryuintStates[2];
 uint uintRepeat;
 } scheduleDef;

 typedef struct faderNode {
 unsigned uBounce : 1;
 unsigned uDirection : 1;
 unsigned uLoop : 1;
 unsigned uPin : 3;
 unsigned uState : 1;
 unsigned uStop : 1;
 volatile ushort* pPort;
 uint uintSteps;
 int intStep;
 int intLastStep;
 uint uintCtr;
 uint uintRepeat;

 void (*pCB)();

 scheduleDef* pSchItem;

 struct faderNode* pNext;
 } faderDef;


 boolean createFader(faderDef* pFader, byte* pPort, byte uPin,
 uint uintSteps, boolean blnDir, boolean blnBounce,
 boolean blnLoop, boolean blnState, boolean blnStopped,
 void (*pCB)());
 int createSchedule(uint uintInc, uint uintRepeat);
 void serviceFaders();
#line 42 "F:/MikroC/KnigntRider/fader.c"
static scheduleDef arySchedule[100];
static faderDef* pFaderLL =  ((void*)0) ;
#line 80 "F:/MikroC/KnigntRider/fader.c"
boolean createFader(faderDef* pFader,
 byte* pPort,
 byte uPin,
 uint uintSteps,
 boolean blnDir,
 boolean blnBounce,
 boolean blnLoop,
 boolean blnState,
 boolean blnStopped,
 void (*pCB)()) {
 if ( pFader ==  ((void*)0)  || pPort ==  ((void*)0)  || uPin > 8 || uintSteps == 0 ) {
 return FALSE;
 }
 memset(pFader, 0, sizeof(faderDef));
 pFader->pPort = pPort;
 pFader->uPin = uPin;
 pFader->uDirection = (blnDir == TRUE) ? 1 : 0;
 pFader->uBounce = (blnBounce == TRUE) ? 1 : 0;
 pFader->uLoop = (blnLoop == TRUE) ? 1 : 0;
 pFader->uState = (blnState == TRUE) ? 1 : 0;
 pFader->uStop = blnStopped;
 pFader->pCB = pCB;
 pFader->uintSteps = uintSteps;

 if ( pFader->uDirection == 1 ) {
 pFader->intStep = pFader->uintSteps - 1;
 }

 pFader->intLastStep = pFader->intStep + 1;

  { pFader->pSchItem = &arySchedule[pFader->intStep]; pFader->uintCtr = pFader->pSchItem->aryuintStates[pFader->uState]; if ( pFader->intLastStep != pFader->intStep ) { pFader->intLastStep = pFader->intStep; pFader->uintRepeat = pFader->pSchItem->uintRepeat; } } ;

 if ( pFaderLL ==  ((void*)0)  ) {
 pFaderLL = pFader;
 } else {

 faderDef* pTail;
 for( pTail=pFaderLL; pTail->pNext!= ((void*)0) ; pTail=pTail->pNext ) {
 }
 pTail->pNext = pFader;
 }
 return TRUE;
}
#line 134 "F:/MikroC/KnigntRider/fader.c"
int createSchedule(uint uintInc, uint uintRepeat) {
 int intSteps, intStep, intRemaining;

 if ( uintInc == 0 ) {

 return 0;
 }

 intSteps = 0;
 intRemaining = 100;
 do {
 intSteps++;
 intRemaining -= uintInc;
 } while( intRemaining > 0 );

 memset(arySchedule, 0, sizeof(arySchedule));
 for( intStep=0; intStep<intSteps; intStep++ ) {
 uint uintOn;
 uintOn = (uint)intStep * (uint)uintInc;
 arySchedule[intStep].aryuintStates[0] = uintOn;
 arySchedule[intStep].aryuintStates[1] = max(0, 100 - uintOn);
 arySchedule[intStep].uintRepeat = uintRepeat;
 }
 return intSteps;
}
#line 169 "F:/MikroC/KnigntRider/fader.c"
void serviceFaders(void) {
 faderDef* pFader;
 int intBit;
 for( pFader=pFaderLL; pFader!= ((void*)0) ; pFader=pFader->pNext ) {
 if ( pFader->uStop ) {

 continue;
 }

 intBit = 1 << pFader->uPin;

 if ( pFader->uState == 0 ) {

 *pFader->pPort |= intBit;
 } else {

 *pFader->pPort &= 0xffff ^ intBit;
 }
 if ( pFader->uintCtr == 0 ) {
 if ( pFader->uState == 1 ) {


 if ( pFader->uintRepeat == 0 ) {

 if ( pFader->uDirection == 0 ) {

 if ( ++pFader->intStep >= pFader->uintSteps ) {

 if ( pFader->uLoop ) {

 pFader->intStep = 0;
 } else
 if ( pFader->uBounce ) {

 pFader->uDirection = 1;
 pFader->intStep = pFader->uintSteps - 1;
 } else {

 pFader->uStop = 1;
 return;
 }
 }
 } else {

 if ( --pFader->intStep <= 0 ) {

 if ( pFader->uLoop ) {

 pFader->intStep = pFader->uintSteps - 1;
 } else if ( pFader->uBounce ) {

 pFader->uDirection = 0;
 pFader->intStep = 0;
 } else {

 pFader->uStop = 1;
 return;
 }
 }
 }
 } else {

 pFader->uintRepeat--;
 }
 }

 pFader->uState = ~pFader->uState;

  { pFader->pSchItem = &arySchedule[pFader->intStep]; pFader->uintCtr = pFader->pSchItem->aryuintStates[pFader->uState]; if ( pFader->intLastStep != pFader->intStep ) { pFader->intLastStep = pFader->intStep; pFader->uintRepeat = pFader->pSchItem->uintRepeat; } } ;

 if ( pFader->pCB !=  ((void*)0)  ) {
 (*pFader->pCB)();
 }
 } else {

 pFader->uintCtr--;
 }
 }
}
