#line 1 "F:/MikroC/KnigntRider/knightRider.c"
#line 1 "f:/mikroc/knigntrider/anim.h"
#line 1 "f:/mikroc/knigntrider/fader.h"
#line 17 "f:/mikroc/knigntrider/fader.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;





 typedef struct {

 uint aryuintStates[2];
 uint uintRepeat;
 } scheduleDef;

 typedef struct faderNode {
 unsigned uBounce : 1;
 unsigned uDirection : 1;
 unsigned uLoop : 1;
 unsigned uPin : 3;
 unsigned uState : 1;
 unsigned uStop : 1;
 volatile ushort* pPort;
 uint uintSteps;
 int intStep;
 int intLastStep;
 uint uintCtr;
 uint uintRepeat;

 void (*pCB)();

 scheduleDef* pSchItem;

 struct faderNode* pNext;
 } faderDef;


 boolean createFader(faderDef* pFader, byte* pPort, byte uPin,
 uint uintSteps, boolean blnDir, boolean blnBounce,
 boolean blnLoop, boolean blnState, boolean blnStopped,
 void (*pCB)());
 int createSchedule(uint uintInc, uint uintRepeat);
 void serviceFaders();
#line 18 "f:/mikroc/knigntrider/anim.h"
 typedef struct {
 byte bPin;
 uint uintPreDelay;
 uint uintPostDelay;
 faderDef fader;
 } outputScheduleDef;

 typedef struct _animDef {
 volatile ushort* pPort;
 byte bTotalSteps;
 union {
 char bits;
 struct {
 unsigned uLoop : 1;
 unsigned uBounce : 1;
 unsigned uDir : 1;
 unsigned uStop : 1;
 };
 } flags;
 outputScheduleDef* parySeq;
 int intIndex;
 byte bStage;
 uint uintCtr;
 struct _animDef* pCurrent;
 struct _animDef* pHead;
 struct _animDef* pTail;
 struct _animDef* pPrev;
 struct _animDef* pNext;
 } animDef;


 void initAnim(animDef* pAnim, int intSteps);
 void joinAnims(animDef* pDst, animDef* pSrc);
 void playAnimation(animDef* pAnim);
#line 16 "F:/MikroC/KnigntRider/knightRider.c"
static volatile outputScheduleDef aryLEDseqB[] = {
 { 0, 0,  ( ((uint)5000)  / 12)  },
 { 1, 0,  ( ((uint)5000)  / 12)  },
 { 2, 0,  ( ((uint)5000)  / 12)  },
 { 3, 0,  ( ((uint)5000)  / 12)  },
 { 4, 0,  ( ((uint)5000)  / 12)  },
 { 5, 0,  ( ((uint)5000)  / 12)  },
 { 6, 0,  ( ((uint)5000)  / 12)  },
 { 7, 0,  ( ((uint)5000)  / 12)  } };
static volatile outputScheduleDef aryLEDseqC[] = {
 { 0, 0,  ( ((uint)5000)  / 12)  },
 { 1, 0,  ( ((uint)5000)  / 12)  },
 { 2, 0,  ( ((uint)5000)  / 12)  },
 { 3, 0,  ( ((uint)5000)  / 12)  },
 { 4, 0,  ( ((uint)5000)  / 12)  },
 { 5, 0,  ( ((uint)5000)  / 12)  },
 { 6, 0,  ( ((uint)5000)  / 12)  },
 { 7, 0,  ( ((uint)5000)  / 12)  } };
static volatile outputScheduleDef aryLEDseqD[] = {
 { 0, 0,  ( ((uint)5000)  / 12)  },
 { 1, 0,  ( ((uint)5000)  / 12)  },
 { 2, 0,  ( ((uint)5000)  / 12)  },
 { 3, 0,  ( ((uint)5000)  / 12)  },
 { 4, 0,  ( ((uint)5000)  / 12)  },
 { 5, 0,  ( ((uint)5000)  / 12)  },
 { 6, 0,  ( ((uint)5000)  / 12)  },
 { 7, 0,  ( ((uint)5000)  / 12)  } };
static volatile animDef animB =
 { &LATB, (sizeof(aryLEDseqB) / sizeof(aryLEDseqB[0])), 3, aryLEDseqB };
static volatile animDef animC =
 { &LATC, (sizeof(aryLEDseqC) / sizeof(aryLEDseqC[0])), 3, aryLEDseqC };
static volatile animDef animD =
 { &LATD, (sizeof(aryLEDseqD) / sizeof(aryLEDseqD[0])), 3, aryLEDseqD };
#line 52 "F:/MikroC/KnigntRider/knightRider.c"
void interrupt() {
 playAnimation(&animB);
 TMR0H = 0xF9;
 TMR0L = 0xC0;
 TMR0IF_bit = 0;
}
#line 61 "F:/MikroC/KnigntRider/knightRider.c"
void main() {
 int intSteps;

 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 TRISB = 0;
 TRISC = 0;
 TRISD = 0;
 LATB = 0;
 LATC = 0;
 LATD = 0;

 intSteps = createSchedule(5, 0);

 initAnim(&animB, intSteps);
 initAnim(&animC, intSteps);
 initAnim(&animD, intSteps);

 joinAnims(&animB, &animC);
 joinAnims(&animB, &animD);


 T0CON.TMR0ON = 1;
 T0CON.T08BIT = 0;
 T0CON.T0CS = 0;
 T0CON.T0SE = 0;
 T0CON.PSA = 1;
 T0CON.T0PS2 = 0;
 T0CON.T0PS1 = 0;
 T0CON.T0PS0 = 0;

 TMR0H = 0xF9;
 TMR0L = 0xC0;
 TMR0IE_bit = 1;

 GIE_bit = 1;

 while( 1 ) {

 }
}
